import React, { Children, isValidElement, Fragment } from 'react';

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var CaseName = 'Case';
var DefaultName = 'Default';
function Switch(props) {
  var expression = props.expression,
    children = props.children;
  var childs = Children.toArray(children);
  var defaultCount = 0;
  var render = null;
  for (var _iterator = _createForOfIteratorHelperLoose(childs), _step; !(_step = _iterator()).done;) {
    var child = _step.value;
    if (isValidElement(child)) {
      var _props = child.props,
        type = child.type;
      var componentName = type.componentName;
      if (componentName === CaseName && expression === _props.value) {
        render = _props.children;
        break;
      }
      if (componentName === DefaultName) {
        if (defaultCount > 0) {
          throw SyntaxError("Statement of '" + DefaultName + "' for [Switch] must be a single one at most!");
        }
        render = _props.children;
        defaultCount++;
      }
    }
  }
  return render;
}
function Case(props) {
  return React.createElement(Fragment, null, props.children);
}
Case.componentName = CaseName;
function Default(props) {
  return React.createElement(Fragment, null, props.children);
}
Default.componentName = DefaultName;
Switch.Case = Case;
Switch.Default = Default;

export default Switch;
export { Case, Default, Switch };
//# sourceMappingURL=react-switch-case-render.esm.js.map
